      subroutine funder(nctri,z,costval,grad,iflag)
      use shared
      implicit none

      integer, intent(in) :: nctri
      double precision, intent(in), dimension(nctr) :: z
      double precision, intent(out) :: costval
      double precision, intent(out), dimension(nctr) :: grad
      integer, intent(out) :: iflag

! common variables
      double precision :: costu, costv, costp, zdotz

      double precision, dimension(nctr) :: x

      integer :: i, j, jidc1, jidc2, jidc3

      x(1:ns) = MATMUL(sqrtPfU,z(1:ns))
      x(ns+1:2*ns) = MATMUL(sqrtPfV,z(ns+1:2*ns))
      x(2*ns+1:3*ns) = MATMUL(sqrtPfPhi,z(2*ns+1:3*ns))

      call convert_from_state(u, v, phi, x, n, m, nt, k_start)

      do j = 2, m-1
          do i = 2, n-1
              jidc1 = i - 1 + (j - 2)*(n - 2)
              jidc2 = jidc1 + (n-2)*(m-2)
              jidc3 = jidc2 + (n-2)*(m-2)

              u(  i, j, k_start) = u(  i, j, k_start) + uback(  i-1, j-1)
              v(  i, j, k_start) = v(  i, j, k_start) + vback(  i-1, j-1)
              phi(i, j, k_start) = phi(i, j, k_start) + phiback(i-1, j-1)
          enddo
      enddo

      call cost_3dvar(u, v, phi, n, m, nt, k_start, uobs, vobs, phiobs, costu, costv, costp, &
           UObsStddev, VObsStddev, PhiObsStddev)

      costval = costu + costv + costp

      zdotz = dot_product(z,z)
      costval = costval + zdotz

      call stadj(uadj, vadj, phiadj, u, v, phi, uobs, vobs, &
                       phiobs, UObsStddev, VObsStddev, PhiObsStddev, n, m, nt, k_start)

      call convert_to_state(uadj, vadj, phiadj, grad, n, m, nt, k_start)

      grad(1:ns) = MATMUL(sqrtPfU,grad(1:ns))
      grad(ns+1:2*ns) = MATMUL(sqrtPfV,grad(ns+1:2*ns))
      grad(2*ns+1:3*ns) = MATMUL(sqrtPfPhi,grad(2*ns+1:3*ns))

      grad = grad + 2*z

      return
      end

      subroutine funder_costonly(costval,z,nctri)

      implicit none

      double precision, intent(out) :: costval
      double precision, dimension(nctri), intent(in) :: z
      integer, intent(in) :: nctri
      double precision, dimension(nctri) :: fakegrad
      integer :: iflag

      call funder(nctri,z,costval,fakegrad,iflag)

      end

      subroutine funder_gradonly(grad,z,nctri)

      implicit none

      double precision, dimension(nctri), intent(out) :: grad
      double precision, dimension(nctri), intent(in) :: z
      integer, intent(in) :: nctri
      double precision :: fakecostval
      integer :: iflag

      call funder(nctri,z,fakecostval,grad,iflag)

      end
